package videoautomat;
import java.io.Serializable;
import java.util.Comparator;

import data.CatalogItem;
import data.Value;
import data.swing.CountingStockTableModel;

/**
 * Comparator used to compare <code>NumberValues</code> of <code>CatalogItems</code> and <code>CountingStockTableModel.Records</code>
 */
public class ComparatorCurrency implements Comparator<CatalogItem>, Serializable {	
	/**
	 * ID for Serialization.
	 */
	private static final long serialVersionUID = -7793618990288671338L;

	/**
	 * Constructs a new <code>ComparatorCurrency</code>
	 *  
	 */
	public ComparatorCurrency() {
	}
	/**
	 * Compares <code>CatalogItemes</code> or <code>CountingStockTableModel.Records</code>.
	 * 
	 * @return 0 if both objects are equal, a positive int if arg0 is greater than arg1, otherwise
	 *              a negative int.
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public int compare(CatalogItem arg0, CatalogItem arg1) {
		if (arg0 instanceof CatalogItem) {
			return ((CatalogItem) arg0).getValue().compareTo(
				((CatalogItem) arg1).getValue());
		}
		if (arg0 instanceof CountingStockTableModel.Record) {
			Value v1 =
				((CountingStockTableModel.Record) arg0)
					.getDescriptor()
					.getValue();
			Value v2 =
				((CountingStockTableModel.Record) arg1)
					.getDescriptor()
					.getValue();
			return v1.compareTo(v2);
		}
		return 0;
	}
}
