package videoautomat;
import sale.Action;
import sale.FormSheet;
import sale.FormSheetContentCreator;
import sale.JDisplayDialog;
import sale.SaleProcess;
import sale.SalesPoint;
import sale.stdforms.MsgForm;

/**
 * This class implements a <code>JDisplayDialog</code> informing the customer that he/she has to insert the correct
 * amount of money. Used when there isn`t enough change in the {@link VideoShop}s <code>MoneyBag</code>.
 */
public class DisplayMoneyStockError extends JDisplayDialog {

	/**
	 * ID for Serialization.
	 */
	private static final long serialVersionUID = 5857508089955396734L;

	/**
	 * Constructs a new <code>DisplayMoneyStockError</code> and shows it.
	 */
	public DisplayMoneyStockError() {
		super();
		FormSheet fs = new MsgForm(
                "No change!",
                "There is not enough change in here.\n"
                    + "Please insert the correct amount of money\n"
                    + "or contact the hotline.");

		fs.addContentCreator(new FormSheetContentCreator() {
			private static final long serialVersionUID = 7987316125303271072L;

			public void createFormSheetContent(FormSheet fs) {
				fs.getButton(FormSheet.BTNID_OK).setAction(new Action() {
					private static final long serialVersionUID = 1060004498677039521L;

					public void doAction(SaleProcess p, SalesPoint sp) {
						closeFormSheet();
					}
				});
			}
		});
		try {			
			popUpFormSheet(fs);
		} catch (InterruptedException e1) {
			e1.printStackTrace();
		}
	}
}
