package videoautomat;
import sale.FormSheet;
import sale.Gate;
import sale.SaleProcess;
import sale.UIGate;
import videoautomat.contentcreator.RegisterContentCreator;

/**
 * A {@link SaleProcess} to register new users.
 *
 * @author Tobias Ruch
 */
public class SaleProcessRegister extends SaleProcess {

   /**
	 * ID for Serialization.
	 */
	private static final long serialVersionUID = -609214820437461076L;

/**
    * Constructs the new process
    *
    */
   public SaleProcessRegister() {
      super("Register Process");
   }

   /**
    * Overridden from SalePrecess to initialize and start the process.
    * This is the only user defined gate. Further gates are only commit and rollback gates.
    */
   
   protected Gate getInitialGate() {
      
      FormSheet register = new FormSheet("Register", 
                                 new RegisterContentCreator("Please type in your data!"), 
                                 false);
      return new UIGate(register, null);
   }

}
