package videoautomat.contentcreator;

import sale.FormSheet;
import sale.FormSheetContentCreator;
import videoautomat.contentcreator.stdactions.TransitWithAction;
import videoautomat.transition.LogOnFailTransition;

/**
 * Content creator to add button with fail transition.
 * @author Alexander Herrmann
 *
 */
public class LogOnMFContentCreator extends FormSheetContentCreator {
    
    /**
	 * ID for Serialization.
	 */
	private static final long serialVersionUID = 760936296585763228L;

	/**
     * Adds button to <code>FormSheet</code> that does the 
     * {@link videoautomat.transition.LogOnFailTransition}
     * @param fs - <code>FormSheet</code> to be changed
     */
    protected void createFormSheetContent(FormSheet fs) {
        fs.getButton(FormSheet.BTNID_OK).setAction(new TransitWithAction(new LogOnFailTransition()));
    }

}
