/*
 * Created on 18.09.2005
 *
 */
package videoautomat.transition;

import java.util.Iterator;

import sale.Gate;
import sale.SaleProcess;
import sale.Transition;
import users.User;
import videoautomat.DisplayMoneyStockError;
import videoautomat.SaleProcessHandBack;
import videoautomat.VideoCassette;
import videoautomat.VideoShop;
import data.NotEnoughMoneyException;
import data.NumberValue;
import data.QuoteValue;
import data.StockItem;
import data.Value;

/**
 * a <code>Transition</code> that calculates the money the user get back, temporary re-adds the handed
 * back videos to the {@link VideoShop}s stock and change to the
 * {@link SaleProcessHandBack#getChangeGate()}. If there is not enough change money in the shop, a
 * {@link DisplayMoneyStockError}opens and it returns the sale.SaleProcess#getRollbackGate()
 * 
 * @author Alexander Herrmann
 *
 */
public class HandBackCalculateSumTransition implements Transition {

    /**
	 * ID for Serialization.
	 */
	private static final long serialVersionUID = 2125670797916690451L;

	/**
     * Gate that performes the handback actions.
     * @author Alexander Herrmann
     */
    public Gate perform(SaleProcess sp, User user) {
        
        SaleProcessHandBack processHandback = (SaleProcessHandBack) sp;
        
        if (processHandback.getTemporaryVideosStoringStock().size(processHandback.getBasket()) == 0)
			return processHandback.restart();

		Iterator it = processHandback.getTemporaryVideosStoringStock().iterator(processHandback.getBasket(), false);
		while (it.hasNext()) {
			StockItem ssi = (StockItem) it.next();
			Value v = null;
			v = ((QuoteValue) ssi.getAssociatedItem(null).getValue()).getOffer();
			NumberValue nv_sum = processHandback.getChangeMoneyNumberValue();
			nv_sum = (NumberValue) nv_sum.add(v.subtract(((VideoCassette) ssi).getCost()));
			processHandback.setChangeMoneyNumberValue(nv_sum);

			VideoShop.getVideoStock().add(ssi.getName(), 1, processHandback.getBasket());
		}
		try{
			VideoShop.getMoneyBag().transferMoney(
					processHandback.getTemporaryChangeMoneyBag(),
			        processHandback.getBasket(),
			        processHandback.getChangeMoneyNumberValue());
		}catch(NotEnoughMoneyException e){
			new DisplayMoneyStockError();
			return processHandback.getRollbackGate();
		}
		
		return processHandback.getChangeGate();
    }

}
