package videoautomat.transition;
import sale.Gate;
import sale.SaleProcess;
import sale.Transition;
import users.User;
import videoautomat.SaleProcessRent;

/**
 * <code>Transition</code> that rollback the money-transactions and leads back to the
 * {@link SaleProcessRent#getInitialGate()}
 * 
 * @author Tobias Ruch
 */
public class RentPayRollbackTransition implements Transition {

    /**
	 * ID for Serialization.
	 */
	private static final long serialVersionUID = -4980523266307469497L;

   /**
    * Performes the transition.
    * @param sp - current process
    * @param user - current user of this process
    * 
    * @return the new <code>Gate</code> which should be shown after the transition    
    */   
   public Gate perform(SaleProcess sp, User user) {
      SaleProcessRent saleProcess = (SaleProcessRent) sp;
      saleProcess.getBasket().rollbackSubBasket(SaleProcessRent.SUB_TMP_MONEY);
	  return saleProcess.restart();
   }

}
